use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my ($out, $var, $color, @c);  # declare all your variables as local or you will get errors

   # header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='$txt{'jobs_header'}'</script>\n";

# monitorfile 1>>2>>3>>4>>5

if (!(-f '/tmp/monitor.log')) { &exe('touch /tmp/monitor.log'); &exe("chmod 666 /tmp/monitor.log"); }

$var=&exe('cat /tmp/monitor.log');
my @l=split(/\n/,$var);          # lines

print "Replication-Job Monitor<br>";

print "<table border='1' style='width:100%'><tr>";
print "<td width='20%'><b>agent/ script</b></td>";
print "<td width='20%'><b>task</b></td>";
print "<td width='20%'><b>details</b></td>";
print "<td width='20%'><b>ask remote</b></td>";
print "<td width='20%'><b>reply remote</b></td>";

foreach $t (@l) {

  @c=();         # colums
  @c=split(/\|/,$t);

  if (!($t =~/sync/)) { next;; }

  if ($c[0] eq "") { $c[0]="\&nbsp;"; }
  if ($c[1] eq "") { $c[1]="\&nbsp;"; }
  if ($c[2] eq "") { $c[2]="\&nbsp;"; }
  if ($c[3] eq "") { $c[3]="\&nbsp;"; }
  if ($c[4] eq "") { $c[4]="\&nbsp;"; }

  # repli script && .. ||  ..
  if (($c[5] eq "") && ($c[6] ne "")) {
       $c[4].=" || $c[6]";
  } else {
       if ($c[5] ne "")  {
          $c[4].=" | $c[5]";
       }
  }

  #remote req ;; -> <br>
     $c[3]=~s/;;/<br>/g;
     $c[4]=~s/;;/<br>/g;

  # alert
  $c[4]=~s/timeout/<font style='color:red'>timeout<\/font>/s;

  # separator ;;
  $c[4]=~s/;;/<br>/gs;
  $c[4]=~s/sudo //gs;        # shorten output
  $c[4]=~s/\/usr\/s?bin\///gs;

  $color="white";
  if ($c[0]=~/agent-request|post-replication/) { $color="#e4efcc"; }  # green
  if ($c[0]=~/agent-cancel/)                   { $color="#efd9cc"; }  # red
  if ($c[0]=~/agent-monitor/)                  { $color="#ccd8ef"; }  # blue
  if ($c[0]=~/\*/)                             { $color="#ddc750"; }  # orange warning       ddc750
  if ($c[0]=~/\*\*|cannot/)                    { $color="#f98383"; }  # red alert

  #shorten long logs
          $c[0]=substr($c[0],0,1000);
          $c[1]=substr($c[1],0,1000);
          $c[2]=substr($c[2],0,1000);

          $c[3]=substr($c[3],0,1000);
          if (length($c[3]) > 999)  {
             $c[3].=" ....";
          }
          $c[4]=substr($c[4],0,1000);
          if (length($c[4]) > 999)  {
             $c[4].=" ....";
          }


  print "<tr style=\"background-color:$color\">\n";

  print "<td width='20%'>$c[0]</td>\n";
  print "<td width='20%'>$c[1]</td>\n";

  #highlight col1
  if ($c[2]=~/start/) {
    print "<td style=\"background-color:#ccd8ef\" width='20%'>$c[2]</td>\n";      # blue receiver   start(ed)
  } else {
    print "<td width='20%'>$c[2]</td>\n";
  }


  ## colspan if 3 ="" and 4 ne ""
  if (($c[3] eq "\&nbsp;") && ($c[4] ne "\&nbsp;")) {
      if ($c[4]=~/zfs receive/) {
           print "<td style=\"background-color:#ccd8ef\" colspan='2'>$c[4]</td>\n";
      } else {
           print "<td colspan='2'>$c[4]</td>\n";
      }

  } else {
       ## colspan if 4 ="" and 3 ne ""
     if (($c[3] ne "\&nbsp;") && ($c[4] eq "\&nbsp;")) {
           print "<td colspan='2'>$c[3]</td>\n";

     } else {

          ## pipe -> zfs receive
           if ($c[4]=~/zfs receive/) {
              print "<td style=\"background-color:#ccd8ef\" colspan='2'>$c[3] | $c[4]</td>\n";
           }  else {

                     if ($c[3]=~/zfs.send/) {
                       print "<td  colspan='2' style=\"background-color:#ccd8ef\" width='20%'>$c[3] | $c[4]</td>\n";      # blue sender
                     } else {
                       print "<td width='20%'>$c[3]</td>\n";
                       print "<td width='20%'>$c[4]</td>\n";
                     }

          }
     }
  }

  print "</tr>\n";
}
print "</table>\n";
print "<br>In case of problems, check this monitor and activity log on sender and receiver side <br>and eventually try to start receiver and then the sender manually from console as root<br><br>";
print "Optionally (shows additional console error messages): restart napp-it from console as root: /etc/init.d/napp-it restart";

} #/ my_action





###############################################
#end of my script, do not delete the line below
1;