use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

                        my ($out, $var);  # declare all your variables as local or you will get errors

                         # header
                         print "<script language='javascript'>document.getElementById('hl').innerHTML='$txt{'jobs_header'}'</script>\n";

                        # declare later needed vars ($hour,..), used in auto.pl
                        use vars qw($date $hour $min $sec $source_ip);

                        ##################################################
                        # debug mode:
                        # create file /tmp/debug
                        # stop execution via
                        # print('message');  exit;  # message is displayed
                        ##################################################

                        # menue actions
                        ###############


                        ###############################################
                        # part 1: do function, if question is answered
                        ##############################################

                        if ($in{'sel_job'} ne "") { $in{'submit_ok'}=""; }        # delete selected

                        if ($in{'submit_ok'} ne "") {      # submit
                            &write_job;       # do it
                        }



                        ##############################
                        # or create a form to ask user
                        ##############################

                        &my_ask;     # source target of sync


} #/ my_action



################################################################################################
sub write_job {    # write job to joblist
################

  # call editpar from menu job create
  if ($in{'action'} eq 'editpar') { return; }        #

    # write data
    ###################################

    my $var="job=backup\n";
    $var.="napp-it=$in{'select_nappit'}\n";
    $var.="userfiles=$in{'select_userfiles'}\n";
    $var.="userrange=$in{'value_userrange'}\n";
    $var.="smbgroups=$in{'select_smbgroups'}\n";
    $var.="idmappings=$in{'select_idmappings'}\n";
    $var.="comstar=$in{'select_comstar'}\n";
    $var.="cluster=$in{'select_cluster'}\n";
    $var.="addscript=$in{'select_addscript'}\n";

    $var.="pool=$in{'select_pool'}\n";
    $var.="fs=$in{'select_fs'}\n";

  # date
    $var.="month=$in{'select_month'}\n";
    $var.="day=$in{'select_day'}\n";
    $var.="hour=$in{'select_hour'}\n";
    $var.="min=$in{'select_min'}\n";
    $var.="status=$in{'select_status'}\n";
    $var.="last=new\n";
  ############################


  # 2. id of this job ########
  ############################
  my $id=time();


  # 3. create job.pre with variables inside
    my $f="$wpath/_log/jobs/$id.par";     # jobfile
    open (F,">$f");
          print F "$var";
    close (F);

  # reload page
  $in{'l3'}="";
  reload;
    exit;
} #/ write job
###############



############### auto_job begin ######### do not remove or rename this line
sub auto_job {   # set needed variables as =variable= - they are stored via sub write_job when creating a job
##############

    # parameter from rewrite/create

    my $id           = "=id=";
    my $name         = "=name=";
    my $action       = "=action=";
    my $condition    = "=condition=";
    my $err          = "=err=";
    my $noerr        = "=noerr=";

    #run action
    my $r=`$action`;


    if ($condition eq "never")  { return(); }
    if ($condition eq "always") { return($r); }

    #condition
    my ($e,$n);
    if ($r=~/$err/s)   { $e="1"; }           # error found
    if ($r=~/$noerr/s) { $n="1"; }           # noerror found

    if ($err eq "")    { $e=""; }
    if ($noerr eq "")  { $n=""; }

    if ($n eq "1")     { return (); }        # is noerror
    if ($e eq "1")     { return ($r); }      # is error

    return();                                # noerror not found and error not found

} #/auto job





###########################
sub my_ask {   #  get job actions
###########################
    my (@source,@target,$s,$t,@g,$g,$r,@w,$w,$hostname,@h,$v);

        &ask('begin','b');
        print " <b style='background-color:#dddddd'>Backup appliance settings:</b> <br><br>";

        # nappit
        &ask('select_nappit','appliance settings like jobs and groups (/var/web-gui/*):','yes');

        if (!($sys{'auto_os'} =~/Linux/i))  {
            #
            # etc files
            &ask('select_userfiles','user and user settings (Unix uid with range, SMB):','yes,no',$in{'select_userfiles'});

            # userrange
            if ($in{'value_userrange'} eq "") { $in{'value_userrange'}="100-30000"; }
            &ask('value_userrange','user range ex 100-30000:',$in{'value_userrange'},'readonlyw100m11');

            # groups files
            &ask('select_smbgroups','SMB groups:','yes,no',$in{'select_smbgroups'});

            # idmappings
            &ask('select_idmappings','ID user mappings (AD, Solarish):','yes,no',$in{'select_idmappings'});

            # comstar
            &ask('select_comstar','Comstar settings:','yes,no',$in{'select_comstar'});

            # cluster
            &ask('select_cluster','Cluster settings (use on Cluster Control only):','yes,no',$in{'select_cluster'});
        }

        # opt files
        &ask('select_addscript','add custom script /var/web-gui/_my/backup.sh:','no,yes',$in{'select_addscript'});

        print "<br>";

        # backup to
        $t=$zfs{'datapools'}; $t=~s/\s/,/g;
        &ask('select_pool','Backup files to pool:',$t);
        &ask('select_fs','Backup to filesystem (autocreated when missing)','/pool/backup_appliance');

        print "<br><br>";
        print "<br><br><b style='background-color:#dddddd'> Timetable</b><br><br>\n";

        &ask('select_month','Month (1..12)','every,every-2,1,2,3,4,5,6,7,8,9,10,11,12');
        &ask('select_day','Day (sun..sat 1..31)','every,sun,mon,tue,wed,thu,fri,sat,mon-fri,mon-sat,sat-sun,first-sat,first-sun,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31','every');
        &ask('select_hour','Hour (0..23)','every,every-2,every-2BC,every-3BC,0,3,6,9,12,15,18,21','0');
        &ask('select_min','Minute (15 Min interval)','every,every-3,every-5,every-10,every-15,every-20,every-30,0,15,30,45,once','0');
        &ask('select_status','Status','manual,active','active');

        print "<a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a>\n";
        print "<div class='info'>Info: 0-3-5 means 0, 3 and 5<br>every-2 (hour) means every two hours<br>every-1BC (hour) means every hour between 7-12 and 13-19 hour (ABCD, each 6 hours from 0..23)";
        print "<br>every month can be every, every-2";
        print "<br>every day can be every, every-2, every-3, every-7, every-14";
        print "<br>every hour can be  every, every-2, every-3, every-4, every-6, every-12, opt followed by ABCD - A=0..5, B=6..11, C=12..17, D=18..23";
        print "<br>every minute can be every, every-3, every-5, every-10, every-15, every-20, every-30";
        print "<br>minute=once means: execute job once after each reboot";

        print "</div><br><br>";

        &ask('end');    # create job , start it manually

}


###############################################
#end of my script, do not delete the line below
1;
