#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my ($out, $var);  # declare all your variables as local or you will get errors

  # menue actions
  ###############


  ###############################################
  # part 1: do function, if question is answered
  ##############################################

    if ($in{'lastform'} eq "modify") {
      &my_update;
    }

    if ($in{'answered'}) {       # question was answered
       &my_edit;          # do it
    }


  #read maps
  @t=();
  &read_dir("$wpath/_my/maps/$in{'member'}","t","","25");

  my $s="";                 # select id and slot
  @t=sort(@t);

  foreach my $t (@t) {
       if (!($t=~/type/)) { next; }
       $t=~s/_type\.txt//;        # name
       $s.="$t,";
  }
  $s=~s/,+$//;


  ##############################
  # or create a form to ask user
  ##############################
  print <<EoF;
       <b>Edit Map</b><hr style="width:340px">
       and enclosure
       <br><br>
EoF

       &ask('begin');
       &ask('select','Edit map',$s);
       &ask('hidden','lastform','select');
       &ask('end');

       # header
       print "<script language='javascript'>document.getElementById('hl').innerHTML='Please select a map'</script>\n";
       &log_end;
} #/ my_action



######################
sub my_update {
######################

  my ($id,$slot,$k);
  my $id_fi="$wpath/_my/maps/$in{'member'}/$in{'map'}\_id.txt";
  my $slot_fi="$wpath/_my/maps/$in{'member'}/$in{'map'}\_slot.txt";

  my $row=$in{'row'};
  my $col=$in{'col'};

  # update id
  $id="";
  for (my $i=0;$i<$row;$i++) {
     for (my $j=0;$j<$col;$j++) {
        $k="id$i.$j";

        #verify
        if (length($in{$k})>10) {       # wwn
          if (!($in{$k} =~/c\d+t\d+.+d0/))     {  &mess("wrong id $in{$k} (must be something like c0t5000CCA36ACFD81Dd0)"); }
        }
        if ($in{$k} =~/^c/) {
          if (!($in{$k} =~/^c\d+.*d\d+/))      {  &mess("wrong id $in{$k} (must be something like c1d4 or a WWN like c0t5000CCA36ACFD81Dd0)"); }
        }

        $id.="$in{$k}\t";
     }
     $id=~s/\t$//;   # remove last
     $id.="\n";
  }

  # update slot
  $slot="";
  for (my $i=0;$i<$row;$i++) {
     for (my $j=0;$j<$col;$j++) {
        $k="slot$i.$j";

        #verify
        if ($in{$k} =~/^e/) {
          if (!($in{$k} =~/^e\d+:[a-z]\d+:s\d+/)) {  &mess("wrong slot format $in{$k} (must be something like e1:m0:s1)");  }
        }
        if ($in{$k} =~/^c/) {
          if (!($in{$k} =~/^c\d+.*d\d+/))      {  &mess("wrong slot format $in{$k} (must be something like c1d4)");      }
        }

        $slot.="$in{$k}\t";
     }
     $slot=~s/\t$//;   # remove last
     $slot.="\n";
  }

  #&print_hash(%in);
  # &mess("$slot<hr>$id");

  print "<br>update map..";

  #write id
  open (PF, ">$id_fi");
    flock(PF, LOCK_EX);
    print PF "$id";
  close (PF);

  #write slot
  open (PF, ">$slot_fi");
    flock(PF, LOCK_EX);
    print PF "$slot";
  close (PF);

  sleep(2);
  $in{'l3'}="";
  &reload;

}

######################
sub my_edit {
######################
   my ($v,$n,$l,$k);

   # read type
   $t=$in{'select'}."_type.txt";
   $t="$wpath/_my/maps/$in{'member'}/$t";

   $t=&my_read($t);
   my @type=split(/\n/,$t);            # [1]=rows, [2]=colums


   # read id
   $t="$wpath/_my/maps/$in{'member'}/$in{'select'}\_id.txt";  # edit this file
   $t=`cat $t`;
   my @id=split(/\n/,$t);

   # id  (tab sep)
   # c0t50014EE25C65626Dd0        c0t50014EE258A497DDd0        c0t50014EE2049EB056d0        c0t5000CCA36ACFD81Dd0
   # c0t5000CCA36ACC3F85d0        c0t5000CCA36AD1A823d0        c0t5000CCA36ACE49E9d0        c0t5000CCA36ACED5FEd0
   # c0t5000CCA36ACFD81Fd0        c0t5000CCA36ACE362Ed0        c0t5000CCA36ACED794d0        c0t5000CCA36ACED692d0
   # c0t50014EE0ADB5CC2Dd0        c0t5000CCA36ACF40F7d0        c0t5000CCA36AD1A88Ed0        c0t5000CCA36AC4CFB7d0

   # read slot
   $t="$wpath/_my/maps/$in{'member'}/$in{'select'}\_slot.txt";  # edit this file
   $t=`cat $t`;
   my @slot=split(/\n/,$t);

   # slot (tab sep)
   # e2:m0:s8         e2:m0:s9         e2:m0:s10        e2:m0:s11
   # e2:m0:s12        e2:m0:s13        e2:m0:s14        e2:m0:s15
   # e2:m0:s16        e2:m0:s17        e2:m0:s18        e2:m0:s19
   # e2:m0:s20        e2:m0:s21        e2:m0:s22        e2:m0:s23

   #hash from values
   my %id;
   my @w;
   for (my $i=0;$i<@id;$i++) {
        @w=();
        @w=split(/\t/,$id[$i]);
        for (my $j=0;$j<@w;$j++) {
          $k="$i.$j";
          $id{$k}=$w[$j];
        }
   }

   my %slot;
   for (my $i=0;$i<@slot;$i++) {
        @w=();
        @w=split(/\t/,$slot[$i]);
        for (my $j=0;$j<@w;$j++) {
          $k="$i.$j";
          $slot{$k}=$w[$j];
        }
   }

   my $r=$type[1];    # rows anc cols
   my $c=$type[2];

#&mess("$r $c");
#&print_array(@values);
#&print_hash(%values);

############
# print form
############
   my $form="<table style='border:solid 2px;margin-left:20px'>\n";

   &ask('begin');
   # rows
   for (my $i=0;$i<$r;$i++) {
        $form .="<tr>";

        # cols
        for (my $j=0;$j<$c;$j++) {
           $k="$i.$j";
           $form.="<td style='padding: 5px 7px 5px 10px; background-color: #eee'>\n";
              $form.="<b>$k</b><br>
              <input type=\"text\" name=\"slot$k\" value=\"$slot{$k}\" style='width:135px'><br>\n";
              $form.="<input type=\"text\" name=\"id$k\" value=\"$id{$k}\" style='width:135px'>";
           $form .="<td>\n";
        }

        $form .="</tr>";
   }
$form.="</table><br><br>";

print $form;

&ask('hidden','lastform','modify');
&ask('hidden','map',$in{'select'});
&ask('hidden','row',$r);
&ask('hidden','col',$c);
&ask('end');

   print "<script language='javascript'>document.getElementById('hl').innerHTML='Edit $in{'select'}'</script>\n";
   &log_end;
   exit;
}





###############################################
#end of my script, do not delete the line below
1;