###############
sub my_action {
###############

  #override with private functions?
  ##################################
  eval { &mylib_menue_pools_import };                   # create this function in a private mylib.pl to replace this action

  my ($var1, $ant, $free, $type, $d, $r);

  # header
  print "<script language='javascript'>document.getElementById('hl').innerHTML='import pool on $in{'member'}'</script>\n";


# 1. edited
if ($in{'answered'}) { &my_import; }     # form -> create

# 2. get form
#########################

# form begin
  &ask('begin');

## name of pool
  print "If no importable pools are shown, open a terminal (admin) and call 'zpool import' or 'zpool import -D'<br>and import via 'zpool import -f poolname<br><br>";

  $d=&zfslib_list_pools('ex,des');
  $r=$d;
  $r=~s/_.*//;  #name of first importable

  &ask('select_pool','Importable pools',$d);               #show (importable) exported and destryoed pools
  &ask('value_name','Name after import',$r);

  print "Options<br><br>";                                 #   options (use in case of problems)

  &ask("select_import","Import with pool name or pool id","name,id");
  if ($current{'on'}=~/linux/i) {
     &ask("select_id","Identify disks after import","by-id,by-uuid,sd[a-z]");
  }

  &ask('checkbox_ro','readonly','option -readonly');
  &ask('checkbox_m','without slog','option -m');
  &ask('checkbox_N','without mount','option -N');
  &ask('checkbox_R','mount as /pool','option -R');

  print " <font style='color:red'>$txt{'form_damaged'}</font>";
  &ask('checkbox_F','try a former pool state on problems','option -F');            # import former state?

  print " <font style='color:red'>Requires a system checkpoint</font>";
  &ask('checkbox_CP','restore a system checkpoint','option --rewind-to-checkpoint');            # import former state?

  &ask('confirm','import',$txt{'form_confirm'});


 print "<br>importable pools:\n";
 print &list2table(&zfslib_list_pools('all,header,state'));


  print "<br><b>Available pools</b><br>";
 &log_add("zpool list -H");
 $d=&exe("zpool list -H");  #pools
 $d=~s/\n+$//s;
 &log_add("$d");
 if ($d eq "") { $r=" -$txt{'none'}-"; } else { $r="$d";}
 print "$r";

 print "<br><br><b>Exported pools</b><br>";
 &log_add("zpool import 53# zpool import");
 $d=&exe("zpool import");  #importable pools
 $d=~s/\n+$//s;
 &log_add("$d");
 if ($d eq "") { $r=" -$txt{'none'}-"; } else { $r="$d";}
 print "$r";

 print "<br><br><b>Destroyed pools</b><br>\n";
 &log_add("zpool import 61# zpool import -D");
 $d=&exe("zpool import -D"); $d=~s/\n+$//s;
 &log_add("$d");
 if ($d eq "") { $r=" -$txt{'none'}-"; } else { $r="$d";}

 print "$r";



} #/ my_action
################



##############################################################################
sub my_import {
################
   my ($r,$i,@w,$n,$type,$what,$pool,$d,$ro,$m,$N,$R,$CP);

   # name of pool-> select_pool

   #action
   #######
   # zpool import name
   ####


   if ( $in{'select_pool'} eq "")   { &mess("there is no pool!"); }


   #strict
   $in{'value_name'}=~s/[^a-zA-Z0-9_\.\-:]//g;            # allowed in name

   $in{'value_name'}=~s/^ +| +$//g;
   if ( $in{'value_name'} eq "")   { &mess("choose a name for imported pool!"); }
   if ( $zfs{'allpools'}=~/\b$in{'value_name'}\b/ ) { &mess("a pool, named $in{'value_name'} already exist, choose another name!"); }


   if ($in{'select_pool'}=~/_D/) {
        $in{'select_pool'}=~s/_D/_/;
        $i="-D ";                         # include Destroyed
   }
   if ($in{'select_import'} eq "name") {  # import by name or id
        $in{'select_pool'}=~s/_.*//;
   } else {
        $in{'select_pool'}=~s/.*_//;
   }

# &print_hash(%in);

   if ($in{'checkbox_ro'} ne "") {
       $ro=" -o readonly=on";
   } else { $ro=""; }

   if ($in{'checkbox_F'} ne "") {          # force import former working state of a damaged pool
     $ro=" -F $ro";
   }

   # only -R or -N
   if ($in{'checkbox_m'} ne "") {
       $m=" -m";
   } else { $m=""; }

   if ($in{'checkbox_R'} ne "") {
       $R=" -R /";
   } else {
       $R="";
       if ($in{'checkbox_N'} ne "") {
          $N=" -N";
        } else { $N=""; }
   }

   $CP="";
   if ($in{'checkbox_CP'} ne "") {
         $CP=" --rewind-to-checkpoint";
   }

   if ($current{'on'}=~/linux/i) {
       my $id="";
       if ($in{'select_id'} eq "by-id")   { $id="  -d /dev/disk/by-id/"; }
       if ($in{'select_id'} eq "by-uuid") { $id="  -d /dev/disk/by-uuid/"; }

    if ($id=~/id/) {
       $d="zpool import$CP$ro$m$N$R -f $i$id $i$in{'select_pool'} $in{'value_name'}";        # use disc-by-id
    } else {
       $d="zpool import$CP$ro$m$N$R -f $i$in{'select_pool'} $in{'value_name'}";
    }

   }


   #&mess($d);
   $d=~s/ +/ /g;
   $i=&exe($d);   # return stderr
   print "$d<hr>$i";

   if (($current{'on'}=~/linux/i) && ($i ne "")) {
      &mess("$d<hr>Could not import. On pool not found try another disk identify method (sd[a-z]).<br>$i");
   }

   sleep(3);

   #something wrong but missing key?
   if (!($i=~/cannot load key/s)) {
      if ($i ne "") { print $i; sleep(2); }
   }

   $in{'l2'}="";
   &reload;
}





###############################################
#end of my script, do not delete the line below
1;