
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

print <<EoF;

<pre><b>Datamover</b>
is a functionality of the Complete and replication extension.
It offers the option to move data with folder structure and ACL permissions intact to another
pool or ZFS filesystem on the same server or optionally to another if it is available with an SMB mount.

<b>How it works</b>
In a first step you create a ruleset to select source, target and a filelist based on fileage,
fileextension, filename or filesize. You can then create and check a filelist to test the ruleset.

In a second step you can the process the move either manually or you can start
the tested move process by an "other job". Each run creates a logfile with moved files.

You can start a datamover as "other job".
The command is:
perl /var/web-gui/data/napp-it/zfsos/_lib/illumos/agents/datamover.pl run_"ruleset.cfg" ex:
perl /var/web-gui/data/napp-it/zfsos/_lib/illumos/agents/datamover.pl run_backup1.cfg

EoF
print "<script language='javascript'>document.getElementById('hl').innerHTML='Datamover Help'</script>\n";
&log_end;

}

###############################################
#end of my script, do not delete the line below
1;