###############
sub my_action {
###############

  #override with private functions?
  ##################################
    eval { &mylib_menue_snaps };                   # create this function in a private mylib.pl to replace this action

    my (@t,@fs,$f,$fs,$ant,$l,$r);

print <<EoF;
<pre><b>Replacing a ZFS File System With a ZFS Clone</b>

You can use the zfs promote command to replace an active ZFS file system with a clone of that file system.
This feature enables you to clone and replace file systems so that the original file system becomes the clone of the specified file system.
In addition, this feature makes it possible to destroy the file system from which the clone was originally created.
Without clone promotion, you cannot destroy an original file system of active clones.
</pre>
EoF

# header
# list clones
print "<script language='javascript'>\$('#hl').html('processing, please wait..')</script>\n";

$ant=&exe("zfs list -H -o name -t filesystem | grep -v rpool/");
$ant.=&exe("zfs list -H -o name -t volume | grep -v rpool/");

@fs=split(/\n/,$ant);

$f="1";
$l="-select a clone-,";
foreach my $fs (@fs) {
     $r=&exe("zfs get -H -o value origin $fs");
     chomp ($r);
     if ($r=~/\@/) {
         $l.="$fs,";
         $f="0";
     }
}

if ($f) { $l="--"; }

print "<script language='javascript'>\$('#hl').html('Promote a clone on $in{'member'}')</script>\n";
print "<br><br>";
if (($in{'select_clone'} eq "") || ($in{'select_clone'} eq "-select-") || ($in{'select_clone'} eq "--")) {
     &ask('begin');
     &ask('select_clone','Promote the clone',$l);
     &ask('confirm','promote a clone','Do you really want to promote the clone?');
     &my_clones();
     exit;
}


print "zfs promote $in{'select_clone'}<br>";
print &exe("zfs promote $in{'select_clone'}");
sleep(2);
reload();


} #/ my_action
##############

###############
sub my_clones {
################
   my $ant=$_[0];
   my $r;

print "<br><br><b>Current Filesystem Clones</b><br><br>";
$ant=&exe("zfs list -H -o name -t filesystem");
@fs=split(/\n/,$ant);

$l="Filesystem\tClone based on Snap\n";
$f="1";

foreach my $fs (@fs) {
     $r=&exe("zfs get -H -o value origin $fs");

     chomp ($r);
     if ($r=~/\@/) {

         # add creation
         $r=&exe("zfs get -H creation $r");
         $r=~s/ +/\t/gs;

         $l.="$fs\t$r\n";
         $f="0";
     }
}
if ($f) { $l.="none"; }
print &list2table($l);

print "<br><br><b>Current Volume Clones</b><br><br>";
$ant=&exe("zfs list -H -o name -t volume");
@fs=split(/\n/,$ant);

$l="Volume\tClone based on Snap\n";
$f="1";

foreach my $fs (@fs) {
     $r=&exe("zfs get -H -o value origin $fs");

     chomp ($r);
     if ($r=~/\@/) {

         # add creation
         $r=&exe("zfs get -H creation $r");
         $r=~s/ +/\t/gs;

         $l.="$fs\t$r\n";
         $f="0";
     }
}
if ($f) { $l.="none"; }
print &list2table($l);

}



###############################################
#end of my script, do not delete the line below
1;
