sub my_action {
###############

    my ($n, $t, @links, $rule, $link, $sname, $proto, $ip, $from, $to, $port, $comment);
    # public @p

    print "<script language='javascript'>document.getElementById('hl').innerHTML='Security Panel (valid Pro or Dev edition required)'</script>\n";

    #local.networks
    $current{'fw_local.networks'}="";
    if (-f "/var/web-gui/_log/local-networks.txt") {
         $current{'fw_local.networks'}=`cat /var/web-gui/_log/local-networks.txt`;
    }

    #debug
#&print_array(@p);
#$current{'fw_local.networks'}=<<EoF;
#192.168.4.0/24
#192.168.5.0/24
#EoF

    @links  = &my_links;               # get network links as reference
    $current{'fw_man_ip'} = &my_ip;    # get management ip (allow always)

    $t=$current{'fw_local.networks'}; $t=~s/\n/, /gs;  $t=~s/(, )+$//gs;

        print <<EoF;
<table style="width;1200px"><tr><td style="vertical-align:top">
<b>Security panel for ip4</b> &nbsp;&nbsp; the first matching block or pass quick rule from top down is active<br>
<font style ="color:red">To block all unwanted services</font>, enable blocking in last rule for all services without a quick pass rule<br>
On problems, disable firewall at console and reboot: svcadm disable ipfilter<br>

</td><td style="width: 55px">&nbsp</td>
<td style="vertical-align:top">
<b>local.networks:</b> with current management host $current{'fw_man_ip'}<br>$t
</td></tr></table>
EoF


$current{'fw_logblock'}="no";


# get current rules  to public @p
@p=();
if (-f "/etc/ipf/ipf.conf") {
   $t=`cat /etc/ipf/ipf.conf`;
   $t=~s/### do not touch rules above .*//s;
   @p=();
   @p=split(/\n/,$t);

   # add on all for general ruleset, delete on save
   foreach my $t (@p) {
           if ($t=~/#n\d/) {
                #log?
                if ($t=~/block in log/) { $current{'fw_logblock'} = "yes"; }

                if (!($t=~/quick on /)) {
                    $t=~s/quick /quick on all /;
                    $t=~s/       //;
                }
           }
   }
}


if ($in{'answered'}) {
   &my_save;
   &reload;
}


# built form
&ask('begin','b');
$n="0";



######################################
# outgoing
print "<br><b>All services outgoing</b><hr>";

# next table header

     print &my_th;

     $n++;
     $link="all";
     $comment="Outgoing traffic";
     $from="127.0.0.1";
     $to=&my_current($link,"to",$comment);                        # identify on  link, reference, comment
     if ($to eq "local.networks") { $comment.=" local.networks";}

     $sname="reply to requests";
     $proto="any";
     $port="any";

     $rule="pass";

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);

# table end
print "</table>\n";
######################################


######################################
# grouping and replication
print "<br><b>napp-it grouping and replication ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="appliance grouping ping" ;
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="any";
     $sname="appliance grouping";
     $proto="tcp/udp/icmp";
     $port="81,49900-65535";
     $rule=&my_current("$link","$comment");                        # identify on link and comment

     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################

######################################
print "<br><br><b>napp-it Webmanagement ingoing</b> (restrict to this management host or a network)<hr>";

# table header
print &my_th;

# allow _this management host always, a subnet or any

     # http
     $n++;
     $comment="http management";
     $rule="pass!";
     $link="all";
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $i="$current{'fw_man_ip'}";
     $sname="appliance http";
     $proto="tcp/udp";
     $port="81";

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);


     # https on port 82
     $n++;
     $comment="https management port 82";
     $rule="pass!";
     $link="all";
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $i="$current{'fw_man_ip'}";
     $sname="appliance https 82";
     $proto="tcp/udp";
     $port="82";

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);


     # https on port 63000 wss
     $n++;
     $comment="optional https/wss websocket port 63000";
     $rule="pass!";
     $link="all";
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $i="$current{'fw_man_ip'}";
     $sname="appliance wss 63000";
     $proto="tcp/udp";
     $port="63000";

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);

     # websocker
     $n++;
     $comment="realtime and graphs";
     $rule="pass!";
     $link="all";
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $i="$current{'fw_man_ip'}";
     $sname="websocket (http only)";
     $proto="tcp/udp";
     $port="3000";

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);



     $n++;
     $comment="Putty and WinSCP";
     $rule="pass!";
     $link="all";
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $i="$current{'fw_man_ip'}";
     $sname="appliance SSH";
     $proto="tcp/udp";
     $port="22";


     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);

     # table end
     print "</table>\n";

     ######################################

######################################
# RSF-1
print "<br><b>RSF-1 request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="RSF-1 cluster services" ;
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="RSF-1";
     $proto="tcp/udp";
     $port="1195,8020";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################




######################################
# SMB
print "<br><b>SMB request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="SMB file services" ;
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="SMB";
     $proto="tcp/udp";
     $port="137,138,139,445";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################

######################################
# NFS
print "<br><b>NFS request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="NFS file services" ;
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="NFS";
     $proto="tcp/udp";
     $port="111,2049";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################


######################################
# iSCSI
print "<br><b>iSCSI request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="iSCSI block services" ;
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="iSCSI";
     $proto="tcp/udp";
     $port="860,3260";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################


######################################
# AFP
print "<br><b>AFP request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="AFP services" ;
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="AFP";
     $proto="tcp/udp";
     $port="427,548";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################

######################################
# FTP
print "<br><b>FTP request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="FTP services" ;
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="FTP";
     $proto="tcp/udp";
     $port="20,21";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################

######################################
# Tftp
print "<br><b>Tftp request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="Trivial ftp";
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="Tftp";
     $proto="tcp/udp";
     $port="69";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################


######################################
# WWW
print "<br><b>WWW http request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="WWW http 80";
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="WWW";
     $proto="tcp/udp";
     $port="80,8080";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################

######################################
# WWW https
print "<br><b>WWW https request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="WWW https 443";
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="WWW https";
     $proto="tcp/udp";
     $port="443";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################


######################################
# mysql
print "<br><b>MySQL database request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="MySQL services" ;
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="MySQL";
     $proto="tcp/udp";
     $port="3306-3307";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";

######################################
# redis
print "<br><b>Redis database request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="Redis services" ;
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="redis";
     $proto="tcp/udp";
     $port="6379";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################

# remote access, ssh, telnet
print "<br><b>Remote SSH access ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="remote managent per SSH, scp, sftp";
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="127.0.0.1";
     $sname="SSH";
     $proto="tcp/udp";
     $port="22";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################


######################################
# rsync
print "<br><b>rsync daemon request ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="rsync services" ;
     $from=&my_current($link,"from",$comment);                     # identify on  link, reference, comment
     if ($from eq "local.networks") { $comment.=" local.networks";}

     $to="localhost";
     $sname="rsync";
     $proto="tcp/udp";
     $port="873";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################



######################################
# all other
print "<br><b>All network services ingoing</b><hr>";

# next table header
print &my_th;

foreach my $link (@links) {
     $n++;
     $comment="all network services without an allow rule above";
     $from="any";
     $to="localhost";
     $sname="all networking";
     $proto="tcp/udp";
     $port="any";
     $rule=&my_current($link,"rule",$comment);                     # identify on  link, reference, comment

     # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8
     print &my_form($rule,$link,$sname,$proto,$from,$to,$port,$n,$comment);
}
# table end
print "</table>\n";
######################################

&ask('hidden',"rules",$n);                               # number of rules

print "<br><hr><br>You must set 'All other' to inactive, if you want to add other rules manually<br><br>";

&ask('select_logblock','Enable log on blocking rules','yes,no',$current{'fw_logblock'});

print "<table><tr><td>";
&ask('end','save only');

print "</td><td>&nbsp;&nbsp;</td><td>";
&ask('end','save and reload');
print "</td></tr></table><br><br><br>";


&log_end;
exit;
&print_var($ip);
&print_array(@l);
&print_hash(%current);


} #/ my_action


#############
sub my_save {
#############

#debug
#&print_hash(%in);

my ($k,$v,$i,$t,$l,$link,$rule,$proto,$port,$from,$to,$comment,@ports,$p,@l);
my $fw=<<EoF;
#
# ipf.conf
#
# IP Filter rules to be loaded during startup
#
# See ipf(4) manpage for more information on
# IP Filter rules syntax.
#
EoF

for ($i=1;$i<=$in{'rules'};$i++) {

         $k="select_rule_$i";                    # allow,block,ignore
         $rule=$in{$k};

         if (!($rule=~/block|pass/))   { next; } # only set block or pass

         $k="link_$i";                           # e1000g0
         $link=$in{$k};

         $k="proto_$i";                          # tcp/udp/icmp
         $proto=$in{$k};

         $k="select_from_$i";                    # tcp/udp/icmp
         $from=$in{$k};
         if (!($from=~/\./)) { $from="any"; }

         $k="select_to_$i";                      # tcp/udp/icmp
         $to=$in{$k};
         if (!($to=~/\./)) { $to="any"; }

         $k="port_$i";                           # tcp/udp/icmp
         $port=$in{$k};
         $port=~s/ +//g;

         @ports=();
         @ports=split(/,/,$port);

         $k="comment_$i";                        # n2 nfs
         $comment="#$in{$k}";
         $comment=~s/ local\.networks//;         # add only on to/from local.networks


         # rule 1: outgoing
         @l=();
         if ($i == 1) {
            if ($to eq "local.networks")   {
                $comment .= " local.networks";
                @l=split(/\n/,$current{'fw_local.networks'});
            } else {
                push (@l,$to);
            }
            foreach my $t (@l) {
                     if (!($t=~/\w/)) { next; }  # not an ip or net
                     #
                     $l="pass out quick from $from to $t keep state". " " x 100;
                     $l=substr($l,0,100); $l.=$comment;
                     $fw.="\n$l";
            }
            next;
         }

         # other rules: ingoing
         @l=();
         if ($from eq "local.networks")   {
                $comment .= " local.networks";
                @l=split(/\n/,$current{'fw_local.networks'});
         } else {
                push (@l,$from);
         }

         foreach my $t (@l) {
                 # build rules
                 ## Allow ping:  pass out quick on dc0 proto icmp from any to any icmp-type 8 keep state
                 if ($proto=~/icmp/i) {
                    $l="$rule in quick on $link proto icmp from $t to $to icmp-type 8 keep state". " " x 100;
                    $l=substr($l,0,100); $l.=$comment;
                    $fw.="\n$l";
                 }

                 ## example: block in quick on e1000g0 proto tcp/udp from any to any port 137 >< 446  keep state  #n2 smb
                 if ($proto=~/tcp/i) {                  # tcp/udp
                    foreach my $p (@ports) {
                       if ($p=~/\-/)  {                 # 137-139
                          $p=~s/\-/ >< /;               # 137 >< 139
                       }
                       $l="$rule in quick on $link proto tcp/udp from $t to $to port = $p keep state". " " x 100;
                       $l=substr($l,0,100); $l.=$comment;
                       $fw.="\n$l";
                    }
                 }
          }
}
$fw.="\n#\n### do not touch rules above. They are autogenerated by napp-it\n";

#add other rules
   $t=`cat /etc/ipf/ipf.conf`;
   $t=~s/.*autogenerated by napp-it//s;
   $t=~s/.*manually added rules//s;
   $t=~s/(\n#)+/\n#/s;                             # remove multiple comment

   # first call
   $t=~s/.*IP Filter rules syntax.\n+//s;

   $fw.="\n# manually added rules\n#\n$t";

   # write to tmp
   @t=split(/\n/,$fw);
   open (PF, ">/tmp/ipf.tmp");                    # ex ex /tmp/nappit/job-scrub_1350378156.request
             flock(PF, LOCK_EX);
             foreach my $t (@t) {
                if (!($t=~/\w|#/)) { next; }      # empty line
                $t=~s/ on all / /;                # only needed in this script (added on open)
                $t=~s/ port = any / /;            # only needed in this script (added on open)
                if ($t=~/></) { $t=~s/port *= */port /; }

                #log
                if (($in{'select_logblock'} eq "yes") && ($t=~/^block/)) {
                  $t=~s/quick/log quick/;
                }
                print PF "$t\n";

             }
             print PF "\n";
   close (PF);


   # debug
   #&print_hash(%in);
   #$t=`cat /tmp/ipf.tmp`;
   #@t=split(/\n/,$t);
   #&print_array(@t);

   &exe("cp /tmp/ipf.tmp /etc/ipf/ipf.conf");
   &exe("rm /tmp/ipf.tmp");

   if ($in{'submit_ok'} =~/reload/) {
        $t=&exe("svcadm disable network/ipfilter");                # enable firewall
        $t=&exe("svcadm clear network/ipfilter");                  # opt clear
        $t=&exe("svcadm enable -rs network/ipfilter");             # enable firewall

        $t= &exe("ipf -Fa -f /etc/ipf/ipf.conf");                  # log
        $t.= &exe("ipfstat -ioh");                                 # active rules
        $t=~s/^\n+//s; $t=~s/\n/<br>/gs;
        print "<br>reload/ enable security<hr>$t";
        &log_end;
        sleep(4);
   }

   &reload;

}

############
sub my_current {
############      link, reference, comment

  my $link=$_[0];
  my $ref=$_[1];
  my $comment=$_[2];
  my $t;

  if ($ref eq "from") {
     #
     # out always from localhost
     if ($comment=~/outgoing/i)    { return("127.0.0.1"); }

     foreach my $p (@p) {
         $t=$p;
         if (($t=~/$link/) && ($t=~/$comment/))  {

             # local netwoks
             if ($p=~/local\.networks/i)    { return("local.networks"); }

             # orherwise use from config
             if ($t=~/from \w/) {
                $t=~s/.* from +//;
                $t=~s/ .*//;
                chomp($t);
                return($t);
              } else {
                return ("any");
              }
         }
    }

  }

  if ($ref eq "to") {

     # in traffic always to localhost
     if   (!($comment=~/outgoing/i)) { return("127.0.0.1"); }

     foreach my $p (@p) {
         $t=$p;

         if ($t=~/$comment/) {

             # local netwoks
             if ($t=~/local\.networks/i)    {   return("local.networks"); }

             if ($t=~/to \w/) {
#
                $t=~s/.* to +//;

                $t=~s/ .*//;
                chomp($t);

                return($t);
              } else {
                return ("any");
              }
         }
     }
  }

  #rule
  if ($ref eq "rule") {
      #
      foreach my $p (@p) {
         $t=$p;
         if (($t=~/$link/) && ($t=~/$comment/)) {
             $t=~s/ .*//;
             chomp($t);
             return($t);
         }
      }
      return ('inactive'); # default
  }


}

############
sub my_th {                # table header
############
$current{'fw_bg'}="";      #startvalue
$current{'fw_all_set'}=""; #startvalue

my $c1="width:90px; border-left: 1px solid black; border-bottom: 1px solid black; padding-left: 3px";
my $c2="width:60px; border-left: 1px solid black; border-bottom: 1px solid black; padding-left: 3px";
my $c3="width:120px; border-left: 1px solid black; border-bottom: 1px solid black; padding-left: 3px";
my $c4="width:120px; border-left: 1px solid black; border-bottom: 1px solid black; padding-left: 3px";
my $c5="width:150px; border-left: 1px solid black; border-bottom: 1px solid black; padding-left: 3px";
my $c6="width:150px; border-left: 1px solid black; border-bottom: 1px solid black; padding-left: 3px";
my $c7="width:120px; border-left: 1px solid black; border-bottom: 1px solid black; padding-left: 3px";
my $c8="width:120px; border-left: 1px solid black; border-bottom: 1px solid black; padding-left: 3px";
my $c9="border-left: 1px solid black; border-bottom: 1px solid black; padding-left: 3px";

my $t=<<EoF;
<table border="0" style="width: 1260px"><tr>
  <td style="$c1"><b>Rule</b></td>
  <td style="$c2"><b>Valid</b></td>
  <td style="$c3"><b>Link</b></td>
  <td style="$c4"><b>Service</b></td>
  <td style="$c5"><b>from IP or net</b></td>
  <td style="$c6"><b>to IP or net</b></td>
  <td style="$c7"><b>Proto</b></td>
  <td style="$c8"><b>Port</b></td>
  <td style="$c9"><b>Comment</b></td>
  </tr>

EoF
return ($t);
}



############ common form
sub my_form {
############        # rule 0, link 1, service 2,  proto 3, from 4, to 5, port 6, number 7, comment 8

my $rule   = $_[0]; # rule: pass, block, inaktive
my $link   = $_[1]; # link
my $sname  = $_[2]; # service name
my $proto  = $_[3]; # proto
my $from   = $_[4]; # ip from
my $to     = $_[5]; # ip to
my $port   = $_[6]; # port
my $n      = $_[7]; # rule number
my $comment= $_[8]; # info/ comment

my ($sel1,$sel2,$sel3,$tmp,$r,$a,$b,$c,$select_from,$select_to,@net,$ip,@ip,$bg1,$bg2,$color);

# include above values to form
&ask('hidden',"link_$n",$link);
&ask('hidden',"proto_$n",$proto);
&ask('hidden',"port_$n",$port);

$tmp=$comment;  $tmp=~s/<br>//g;                           # <br> for form only
&ask('hidden',"comment_$n","n$n $tmp");

# dark grey, grey
if (($current{'fw_bg'} eq "") || ($current{'fw_bg'} eq "#f0f1f4")) {
       $current{'fw_bg'}="#d9dbe1";
} else {
       $current{'fw_bg'} = "#f0f1f4";
}

my $color=$current{'fw_bg'};

if ($current{'fw_all_set'} ne "1") {
     if ($rule=~/pass/)  { $color="#defcd2"; }    # green
     if ($rule=~/block/) { $color="#fecfcf"; }    # red
}

# when on all is set to block or pass, all other backgrounds are greyed
if (($link eq "all") && ($rule=~/block|pass/))  {
   $current{'fw_all_set'}="1";
}

# override: napp-it webmanagement always green
if ($comment =~/realtime|https? management|Putty|optional https/)             {
  $color="#defcd2";      # green
}


if ($rule=~/!/) {         # force setting
     $rule=~s/!//;
     $r=<<EoF;

        <select name="select_rule_$n" class="input">
                $sel1="<option>$rule</option>";
        </select>
EoF
} else {

     $sel1=&my_selected("inactive",$rule);
     $sel2=&my_selected("block",$rule);
     $sel3=&my_selected("pass",$rule);

     # outgoing only pass or inactive
     if ($comment=~/outgoing/i) {
       $sel1="";
       $sel2="";           # out always allowed, can only restrict to hosts
     }

     $r=<<EoF;

        <select name="select_rule_$n" class="input">
                $sel1
                $sel2
                $sel3
        </select>
EoF
}


# select from and to based on management ip, v4 only
@net=();
$ip=$current{'fw_man_ip'};
if ($ip=~/\d+\.\d+/) {
     @ip=split(/\./,$ip);
     $a="$ip[0].0.0.0/8";
     $b="$ip[0].$ip[1].0.0/16";
     $c="$ip[0].$ip[1].$ip[2].0/24";

     $sel_from="<select name=\"select_from_$n\" class=\"input\">\n";
     $sel_from.="\n".&my_selected("any","$from");

     if ($current{'fw_local.networks'} ne "") {
         if ($comment=~/ local.networks/) {          # marker, that the list is active
            $sel_from.="\n".&my_selected("local.networks","local.networks");
         } else {
            $sel_from.="\n".&my_selected("local.networks","-");
         }
     }

     $sel_from.="\n".&my_selected($ip,$from);
     $sel_from.="\n".&my_selected($c,$from);
     $sel_from.="\n".&my_selected($b,$from);
     $sel_from.="\n".&my_selected($a,$from);
     $sel_from.="</select>";

     if ($comment=~/outgoing/i) {
            $sel_from="appliance ZFS server";
            &ask('hidden',"select_from_$n",'localhost');
     }

     $sel_to="<select name=\"select_to_$n\" class=\"input\">\n";
     $sel_to.="\n".&my_selected("any",$to);

     if ($current{'fw_local.networks'} ne "") {
         if ($comment=~/ local.networks/) {          # marker, that the list is active
            $sel_to.="\n".&my_selected("local.networks","local.networks");
         } else {
            $sel_to.="\n".&my_selected("local.networks","-");
         }
     }

     $sel_to.="\n".&my_selected($ip,$to);
     $sel_to.="\n".&my_selected($c,$to);
     $sel_to.="\n".&my_selected($b,$to);
     $sel_to.="\n".&my_selected($a,$to);
     $sel_to.="</select>";

     # all outgoing packets from localhost
     if (!($comment=~/outgoing/i)) {
            $sel_to="appliance ZFS server";
            &ask("hidden","select_to_$n","localhost");
     }

} else {
     &ask('hidden',"select_from_$n",'any');
     &ask('hidden',"select_to_$n",'any');
     $sel_from="any";
     $sel_to="any";
}

#padding: 2px 1px 0 1px;
if ($link eq "all") {
  $link="<b>all</b>";
  $sname="<b>$sname</b>";
}


my $c1="width:90px;  height: 10px; border: 1px solid white; background-color:$color; padding: 2px 0 2px 2px; vertical-align: middle";
my $c2="width:60px;  height: 10px; border: 1px solid white; background-color:$color; padding: 0 0 0 2px; vertical-align: middle";
my $c3="width:120px; height: 10px; border: 1px solid white; background-color:$color; padding: 0 0 0 2px; vertical-align: middle";
my $c4="width:120px; height: 10px; border: 1px solid white; background-color:$color; padding: 0 0 0 2px; vertical-align: middle";
my $c5="width:150px; height: 10px; border: 1px solid white; background-color:$color; padding: 0 0 0 2px; vertical-align: middle";
my $c6="width:150px; height: 10px; border: 1px solid white; background-color:$color; padding: 0 0 0 2px; vertical-align: middle";
my $c7="width:120px; height: 10px; border: 1px solid white; background-color:$color; padding: 0 0 0 2px; vertical-align: middle";
my $c8="width:120px; height: 10px; border: 1px solid white; background-color:$color; padding: 0 0 0 2px; vertical-align: middle";
my $c9="height: 10px; border: 1px solid white; background-color:$color; padding: 0 0 0 2px; vertical-align: middle";

$t=<<EoF;

<tr>
   <td align="left" style="$c1">$r</td>
   <td align="left" style="$c2">quick</td>
   <td align="left" style="$c3">$link</td>
   <td align="left" style="$c4">$sname</td>
   <td align="left" style="$c5">$sel_from</td>
   <td align="left" style="$c6">$sel_to</td>
   <td align="left" style="$c7">$proto</td>
   <td align="left" style="$c8">$port</td>
   <td align="left" style="$c9">#n$n $comment</td>
  </tr>


EoF
return ($t);
}

#################
sub my_selected {  # par: option, current
#################
    #
    my $option =$_[0];
    my $current=$_[1];
    if ($current eq $option) {
       return ("<option selected>$option</option>");
    } else {
       return ("<option>$option</option>");
    }
}

#############
sub my_links {
##############
   my ($r,$t,@t);
   $r=&exe("dladm show-link");

   # get links
   @t=split(/\n/,$r);

   push(@l,"all");

   foreach my $t (@t) {
         chomp($t);
         if ($t=~/up / ) {  # state: up
             $t=~s/ .*//;   # link name
             push(@l,$t);
         }
   }

   if (!($cfg{'ver'}=~/p|a|c|m|r/)) { print "$txt{'pro'}"; exit; }

   return(@l);
}

###########
sub my_ip {
###########
    # current management machine
    return($ENV{'REMOTE_ADDR'});
    &print_hash(%ENV);
}



###############################################
#end of my script, do not delete the line below
1;